Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::IndexScalarQuantizer Struct Reference
Inheritance diagram for faiss::IndexScalarQuantizer:

## Public Member Functions
| IndexScalarQuantizer (int d, ScalarQuantizer::QuantizerType qtype, MetricType metric=METRIC_L2)
void | train (idx_t n, const float *x) override
void | add (idx_t n, const float *x) override
void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
void | reset () override
| removes all elements from the database.
void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const override
void | reconstruct (idx_t key, float *recons) const override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_L2)
virtual void | add_with_ids (idx_t n, const float *x, const long *xids)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual long | remove_ids (const IDSelector &sel)
virtual void | search_and_reconstruct (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const

## Public Attributes
ScalarQuantizer | sq
| Used to encode the vectors.
std::vector< uint8_t > | codes
| Codes. Size ntotal * pq.code_size.
size_t | code_size
Public Attributes inherited from faiss::Index
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members
Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

Definition at line 99 of file IndexScalarQuantizer.h.

## Constructor & Destructor Documentation

faiss::IndexScalarQuantizer::IndexScalarQuantizer | ( | int | d,
|  | ScalarQuantizer::QuantizerType | qtype,
|  | MetricType | metric = `METRIC_L2`
| ) |  |

Constructor.

Parameters

  d | dimensionality of the input vectors
  M | number of subquantizers
  nbits | number of bit per subvector index

Definition at line 795 of file IndexScalarQuantizer.cpp.

## Member Function Documentation

void faiss::IndexScalarQuantizer::add | ( | idx_t | n,
|  | const float * | x
| ) |  |
| override virtual

Add n vectors of dimension d to the index.

Vectors are implicitly assigned labels ntotal .. ntotal + n - 1 This function slices the input vectors in chuncks smaller than blocksize_add and calls add_core.

Parameters

  x | input matrix, size n * d

Implements faiss::Index.

Definition at line 815 of file IndexScalarQuantizer.cpp.

void faiss::IndexScalarQuantizer::reconstruct | ( | idx_t | key,
|  | float * | recons
| ) |  | const
| override virtual

Reconstruct a stored vector (or an approximation if lossy coding)

this function may not be defined for some indexes

Parameters

  key | id of the vector to reconstruct
  recons | reconstucted vector (size d)

Reimplemented from faiss::Index.

Definition at line 901 of file IndexScalarQuantizer.cpp.

void faiss::IndexScalarQuantizer::reconstruct_n | ( | idx_t | i0,
|  | idx_t | ni,
|  | float * | recons
| ) |  | const
| override virtual

Reconstruct vectors i0 to i0 + ni - 1

this function may not be defined for some indexes

Parameters

  recons | reconstucted vector (size ni * d)

Reimplemented from faiss::Index.

Definition at line 891 of file IndexScalarQuantizer.cpp.

void faiss::IndexScalarQuantizer::search | ( | idx_t | n,
|  | const float * | x,
|  | idx_t | k,
|  | float * | distances,
|  | idx_t * | labels
| ) |  | const
| override virtual

query n vectors of dimension d to the index.

return at most k vectors. If there are not enough results for a query, the result array is padded with -1s.

Parameters

  x | input vectors to search, size n * d
  labels | output labels of the NNs, size n*k
  distances | output pairwise distances, size n*k

Implements faiss::Index.

Definition at line 870 of file IndexScalarQuantizer.cpp.

void faiss::IndexScalarQuantizer::train | ( | idx_t | n,
|  | const float * | x
| ) |  |
| override virtual

Perform training on a representative set of vectors

Parameters

  n | nb of training vectors
  x | training vecors, size n * d

Reimplemented from faiss::Index.

Definition at line 809 of file IndexScalarQuantizer.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/IndexScalarQuantizer.h
- /data/users/matthijs/github_faiss/faiss/IndexScalarQuantizer.cpp